using System;
using System.Data;
using NorthwindWinFormViewsDynamic_CS.DataLayer;
using NorthwindWinFormViewsDynamic_CS.BusinessObject;

namespace NorthwindWinFormViewsDynamic_CS.BusinessObject.Base
{
     /// <summary>
     /// Base class for CategorySalesFor1997.  Do not make changes to this class,
     /// instead, put additional code in the CategorySalesFor1997 class
     /// </summary>
     public class CategorySalesFor1997Base
     {
         /// <summary>
         /// Gets or Sets CategoryName
         /// </summary>
         public string CategoryName { get; set; }

         /// <summary>
         /// Gets or Sets CategorySales
         /// </summary>
         public decimal? CategorySales { get; set; }

         /// <summary>
         /// Gets or Sets CategorySalesTotal
         /// </summary>
         public decimal CategorySalesTotal { get; set; }


         /// <summary>
         /// Constructor
         /// </summary>
         public CategorySalesFor1997Base()
         {
         }

         /// <summary>
         /// Gets the total number of records in the CategorySalesFor1997 table
         /// </summary>
         public static int GetRecordCount()
         {
             return CategorySalesFor1997DataLayer.GetRecordCount();
         }

         /// <summary>
         /// Selects records as a collection (List) of CategorySalesFor1997 sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         /// </summary>
         public static CategorySalesFor1997Collection SelectSkipAndTake(int rows, int startRowIndex, out int totalRowCount, string sortByExpression)
         {
             totalRowCount = GetRecordCount();
             sortByExpression = GetSortExpression(sortByExpression);

             return CategorySalesFor1997DataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows);
         }

         /// <summary>
         /// Selects records as a collection (List) of CategorySalesFor1997 sorted by the sortByExpression starting from the startRowIndex.
         /// </summary>
         public static CategorySalesFor1997Collection SelectSkipAndTake(int rows, int startRowIndex, string sortByExpression)
         {
             sortByExpression = GetSortExpression(sortByExpression);
             return CategorySalesFor1997DataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows);
         }

         private static string GetSortExpression(string sortByExpression)
         {
             if (String.IsNullOrEmpty(sortByExpression) || sortByExpression == " asc")
                 sortByExpression = "CategoryName";
             else if (sortByExpression.Contains(" asc"))
                 sortByExpression = sortByExpression.Replace(" asc", "");

             return sortByExpression;
         }

         /// <summary>
         /// Compares CategoryName used for sorting
         /// </summary>
         public static Comparison<CategorySalesFor1997> ByCategoryName = delegate(CategorySalesFor1997 x, CategorySalesFor1997 y)
         {
             string value1 = x.CategoryName ?? String.Empty;
             string value2 = y.CategoryName ?? String.Empty;
             return value1.CompareTo(value2);
         };

         /// <summary>
         /// Compares CategorySales used for sorting
         /// </summary>
         public static Comparison<CategorySalesFor1997> ByCategorySales = delegate(CategorySalesFor1997 x, CategorySalesFor1997 y)
         {
             return Nullable.Compare(x.CategorySales, y.CategorySales);
         };

     }
}
