using System;
using System.Data;
using NorthwindWinFormViewsDynamic_CS.DataLayer;
using NorthwindWinFormViewsDynamic_CS.BusinessObject;

namespace NorthwindWinFormViewsDynamic_CS.BusinessObject.Base
{
     /// <summary>
     /// Base class for CustomerAndSuppliersByCity.  Do not make changes to this class,
     /// instead, put additional code in the CustomerAndSuppliersByCity class
     /// </summary>
     public class CustomerAndSuppliersByCityBase
     {
         /// <summary>
         /// Gets or Sets City
         /// </summary>
         public string City { get; set; }

         /// <summary>
         /// Gets or Sets CompanyName
         /// </summary>
         public string CompanyName { get; set; }

         /// <summary>
         /// Gets or Sets ContactName
         /// </summary>
         public string ContactName { get; set; }

         /// <summary>
         /// Gets or Sets Relationship
         /// </summary>
         public string Relationship { get; set; }


         /// <summary>
         /// Constructor
         /// </summary>
         public CustomerAndSuppliersByCityBase()
         {
         }

         /// <summary>
         /// Gets the total number of records in the CustomerAndSuppliersByCity table
         /// </summary>
         public static int GetRecordCount()
         {
             return CustomerAndSuppliersByCityDataLayer.GetRecordCount();
         }

         /// <summary>
         /// Selects records as a collection (List) of CustomerAndSuppliersByCity sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         /// </summary>
         public static CustomerAndSuppliersByCityCollection SelectSkipAndTake(int rows, int startRowIndex, out int totalRowCount, string sortByExpression)
         {
             totalRowCount = GetRecordCount();
             sortByExpression = GetSortExpression(sortByExpression);

             return CustomerAndSuppliersByCityDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows);
         }

         /// <summary>
         /// Selects records as a collection (List) of CustomerAndSuppliersByCity sorted by the sortByExpression starting from the startRowIndex.
         /// </summary>
         public static CustomerAndSuppliersByCityCollection SelectSkipAndTake(int rows, int startRowIndex, string sortByExpression)
         {
             sortByExpression = GetSortExpression(sortByExpression);
             return CustomerAndSuppliersByCityDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows);
         }

         private static string GetSortExpression(string sortByExpression)
         {
             if (String.IsNullOrEmpty(sortByExpression) || sortByExpression == " asc")
                 sortByExpression = "City";
             else if (sortByExpression.Contains(" asc"))
                 sortByExpression = sortByExpression.Replace(" asc", "");

             return sortByExpression;
         }

         /// <summary>
         /// Compares City used for sorting
         /// </summary>
         public static Comparison<CustomerAndSuppliersByCity> ByCity = delegate(CustomerAndSuppliersByCity x, CustomerAndSuppliersByCity y)
         {
             string value1 = x.City ?? String.Empty;
             string value2 = y.City ?? String.Empty;
             return value1.CompareTo(value2);
         };

         /// <summary>
         /// Compares CompanyName used for sorting
         /// </summary>
         public static Comparison<CustomerAndSuppliersByCity> ByCompanyName = delegate(CustomerAndSuppliersByCity x, CustomerAndSuppliersByCity y)
         {
             string value1 = x.CompanyName ?? String.Empty;
             string value2 = y.CompanyName ?? String.Empty;
             return value1.CompareTo(value2);
         };

         /// <summary>
         /// Compares ContactName used for sorting
         /// </summary>
         public static Comparison<CustomerAndSuppliersByCity> ByContactName = delegate(CustomerAndSuppliersByCity x, CustomerAndSuppliersByCity y)
         {
             string value1 = x.ContactName ?? String.Empty;
             string value2 = y.ContactName ?? String.Empty;
             return value1.CompareTo(value2);
         };

         /// <summary>
         /// Compares Relationship used for sorting
         /// </summary>
         public static Comparison<CustomerAndSuppliersByCity> ByRelationship = delegate(CustomerAndSuppliersByCity x, CustomerAndSuppliersByCity y)
         {
             string value1 = x.Relationship ?? String.Empty;
             string value2 = y.Relationship ?? String.Empty;
             return value1.CompareTo(value2);
         };

     }
}
