using System;
using System.Data;
using NorthwindWinFormViewsDynamic_CS.DataLayer;
using NorthwindWinFormViewsDynamic_CS.BusinessObject;

namespace NorthwindWinFormViewsDynamic_CS.BusinessObject.Base
{
     /// <summary>
     /// Base class for ProductSalesFor1997.  Do not make changes to this class,
     /// instead, put additional code in the ProductSalesFor1997 class
     /// </summary>
     public class ProductSalesFor1997Base
     {
         /// <summary>
         /// Gets or Sets CategoryName
         /// </summary>
         public string CategoryName { get; set; }

         /// <summary>
         /// Gets or Sets ProductName
         /// </summary>
         public string ProductName { get; set; }

         /// <summary>
         /// Gets or Sets ProductSales
         /// </summary>
         public decimal? ProductSales { get; set; }

         /// <summary>
         /// Gets or Sets ProductSalesTotal
         /// </summary>
         public decimal ProductSalesTotal { get; set; }


         /// <summary>
         /// Constructor
         /// </summary>
         public ProductSalesFor1997Base()
         {
         }

         /// <summary>
         /// Gets the total number of records in the ProductSalesFor1997 table
         /// </summary>
         public static int GetRecordCount()
         {
             return ProductSalesFor1997DataLayer.GetRecordCount();
         }

         /// <summary>
         /// Selects records as a collection (List) of ProductSalesFor1997 sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         /// </summary>
         public static ProductSalesFor1997Collection SelectSkipAndTake(int rows, int startRowIndex, out int totalRowCount, string sortByExpression)
         {
             totalRowCount = GetRecordCount();
             sortByExpression = GetSortExpression(sortByExpression);

             return ProductSalesFor1997DataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows);
         }

         /// <summary>
         /// Selects records as a collection (List) of ProductSalesFor1997 sorted by the sortByExpression starting from the startRowIndex.
         /// </summary>
         public static ProductSalesFor1997Collection SelectSkipAndTake(int rows, int startRowIndex, string sortByExpression)
         {
             sortByExpression = GetSortExpression(sortByExpression);
             return ProductSalesFor1997DataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows);
         }

         private static string GetSortExpression(string sortByExpression)
         {
             if (String.IsNullOrEmpty(sortByExpression) || sortByExpression == " asc")
                 sortByExpression = "CategoryName";
             else if (sortByExpression.Contains(" asc"))
                 sortByExpression = sortByExpression.Replace(" asc", "");

             return sortByExpression;
         }

         /// <summary>
         /// Compares CategoryName used for sorting
         /// </summary>
         public static Comparison<ProductSalesFor1997> ByCategoryName = delegate(ProductSalesFor1997 x, ProductSalesFor1997 y)
         {
             string value1 = x.CategoryName ?? String.Empty;
             string value2 = y.CategoryName ?? String.Empty;
             return value1.CompareTo(value2);
         };

         /// <summary>
         /// Compares ProductName used for sorting
         /// </summary>
         public static Comparison<ProductSalesFor1997> ByProductName = delegate(ProductSalesFor1997 x, ProductSalesFor1997 y)
         {
             string value1 = x.ProductName ?? String.Empty;
             string value2 = y.ProductName ?? String.Empty;
             return value1.CompareTo(value2);
         };

         /// <summary>
         /// Compares ProductSales used for sorting
         /// </summary>
         public static Comparison<ProductSalesFor1997> ByProductSales = delegate(ProductSalesFor1997 x, ProductSalesFor1997 y)
         {
             return Nullable.Compare(x.ProductSales, y.ProductSales);
         };

     }
}
