using System;
using System.Data;
using NorthwindWinFormViewsDynamic_CS.DataLayer;
using NorthwindWinFormViewsDynamic_CS.BusinessObject;

namespace NorthwindWinFormViewsDynamic_CS.BusinessObject.Base
{
     /// <summary>
     /// Base class for ProductsAboveAveragePrice.  Do not make changes to this class,
     /// instead, put additional code in the ProductsAboveAveragePrice class
     /// </summary>
     public class ProductsAboveAveragePriceBase
     {
         /// <summary>
         /// Gets or Sets ProductName
         /// </summary>
         public string ProductName { get; set; }

         /// <summary>
         /// Gets or Sets UnitPrice
         /// </summary>
         public decimal? UnitPrice { get; set; }

         /// <summary>
         /// Gets or Sets UnitPriceTotal
         /// </summary>
         public decimal UnitPriceTotal { get; set; }


         /// <summary>
         /// Constructor
         /// </summary>
         public ProductsAboveAveragePriceBase()
         {
         }

         /// <summary>
         /// Gets the total number of records in the ProductsAboveAveragePrice table
         /// </summary>
         public static int GetRecordCount()
         {
             return ProductsAboveAveragePriceDataLayer.GetRecordCount();
         }

         /// <summary>
         /// Selects records as a collection (List) of ProductsAboveAveragePrice sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         /// </summary>
         public static ProductsAboveAveragePriceCollection SelectSkipAndTake(int rows, int startRowIndex, out int totalRowCount, string sortByExpression)
         {
             totalRowCount = GetRecordCount();
             sortByExpression = GetSortExpression(sortByExpression);

             return ProductsAboveAveragePriceDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows);
         }

         /// <summary>
         /// Selects records as a collection (List) of ProductsAboveAveragePrice sorted by the sortByExpression starting from the startRowIndex.
         /// </summary>
         public static ProductsAboveAveragePriceCollection SelectSkipAndTake(int rows, int startRowIndex, string sortByExpression)
         {
             sortByExpression = GetSortExpression(sortByExpression);
             return ProductsAboveAveragePriceDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows);
         }

         private static string GetSortExpression(string sortByExpression)
         {
             if (String.IsNullOrEmpty(sortByExpression) || sortByExpression == " asc")
                 sortByExpression = "ProductName";
             else if (sortByExpression.Contains(" asc"))
                 sortByExpression = sortByExpression.Replace(" asc", "");

             return sortByExpression;
         }

         /// <summary>
         /// Compares ProductName used for sorting
         /// </summary>
         public static Comparison<ProductsAboveAveragePrice> ByProductName = delegate(ProductsAboveAveragePrice x, ProductsAboveAveragePrice y)
         {
             string value1 = x.ProductName ?? String.Empty;
             string value2 = y.ProductName ?? String.Empty;
             return value1.CompareTo(value2);
         };

         /// <summary>
         /// Compares UnitPrice used for sorting
         /// </summary>
         public static Comparison<ProductsAboveAveragePrice> ByUnitPrice = delegate(ProductsAboveAveragePrice x, ProductsAboveAveragePrice y)
         {
             return Nullable.Compare(x.UnitPrice, y.UnitPrice);
         };

     }
}
