using System;
using System.Data;
using NorthwindWinFormViewsDynamic_CS.DataLayer;
using NorthwindWinFormViewsDynamic_CS.BusinessObject;

namespace NorthwindWinFormViewsDynamic_CS.BusinessObject.Base
{
     /// <summary>
     /// Base class for SummaryOfSalesByQuarter.  Do not make changes to this class,
     /// instead, put additional code in the SummaryOfSalesByQuarter class
     /// </summary>
     public class SummaryOfSalesByQuarterBase
     {
         /// <summary>
         /// Gets or Sets ShippedDate
         /// </summary>
         public DateTime? ShippedDate { get; set; }

         /// <summary>
         /// Gets or Sets OrderID
         /// </summary>
         public int OrderID { get; set; }

         /// <summary>
         /// Gets or Sets Subtotal
         /// </summary>
         public decimal? Subtotal { get; set; }

         /// <summary>
         /// Gets or Sets SubtotalTotal
         /// </summary>
         public decimal SubtotalTotal { get; set; }


         /// <summary>
         /// Constructor
         /// </summary>
         public SummaryOfSalesByQuarterBase()
         {
         }

         /// <summary>
         /// Gets the total number of records in the SummaryOfSalesByQuarter table
         /// </summary>
         public static int GetRecordCount()
         {
             return SummaryOfSalesByQuarterDataLayer.GetRecordCount();
         }

         /// <summary>
         /// Selects records as a collection (List) of SummaryOfSalesByQuarter sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         /// </summary>
         public static SummaryOfSalesByQuarterCollection SelectSkipAndTake(int rows, int startRowIndex, out int totalRowCount, string sortByExpression)
         {
             totalRowCount = GetRecordCount();
             sortByExpression = GetSortExpression(sortByExpression);

             return SummaryOfSalesByQuarterDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows);
         }

         /// <summary>
         /// Selects records as a collection (List) of SummaryOfSalesByQuarter sorted by the sortByExpression starting from the startRowIndex.
         /// </summary>
         public static SummaryOfSalesByQuarterCollection SelectSkipAndTake(int rows, int startRowIndex, string sortByExpression)
         {
             sortByExpression = GetSortExpression(sortByExpression);
             return SummaryOfSalesByQuarterDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows);
         }

         private static string GetSortExpression(string sortByExpression)
         {
             if (String.IsNullOrEmpty(sortByExpression) || sortByExpression == " asc")
                 sortByExpression = "ShippedDate";
             else if (sortByExpression.Contains(" asc"))
                 sortByExpression = sortByExpression.Replace(" asc", "");

             return sortByExpression;
         }

         /// <summary>
         /// Compares ShippedDate used for sorting
         /// </summary>
         public static Comparison<SummaryOfSalesByQuarter> ByShippedDate = delegate(SummaryOfSalesByQuarter x, SummaryOfSalesByQuarter y)
         {
             return Nullable.Compare(x.ShippedDate, y.ShippedDate);
         };

         /// <summary>
         /// Compares OrderID used for sorting
         /// </summary>
         public static Comparison<SummaryOfSalesByQuarter> ByOrderID = delegate(SummaryOfSalesByQuarter x, SummaryOfSalesByQuarter y)
         {
             return x.OrderID.CompareTo(y.OrderID);
         };

         /// <summary>
         /// Compares Subtotal used for sorting
         /// </summary>
         public static Comparison<SummaryOfSalesByQuarter> BySubtotal = delegate(SummaryOfSalesByQuarter x, SummaryOfSalesByQuarter y)
         {
             return Nullable.Compare(x.Subtotal, y.Subtotal);
         };

     }
}
