using System;
using System.Data;
using NorthwindWinFormViewsDynamic_CS.DataLayer;
using NorthwindWinFormViewsDynamic_CS.BusinessObject;

namespace NorthwindWinFormViewsDynamic_CS.BusinessObject.Base
{
     /// <summary>
     /// Base class for SummaryOfSalesByYear.  Do not make changes to this class,
     /// instead, put additional code in the SummaryOfSalesByYear class
     /// </summary>
     public class SummaryOfSalesByYearBase
     {
         /// <summary>
         /// Gets or Sets ShippedDate
         /// </summary>
         public DateTime? ShippedDate { get; set; }

         /// <summary>
         /// Gets or Sets OrderID
         /// </summary>
         public int OrderID { get; set; }

         /// <summary>
         /// Gets or Sets Subtotal
         /// </summary>
         public decimal? Subtotal { get; set; }

         /// <summary>
         /// Gets or Sets SubtotalTotal
         /// </summary>
         public decimal SubtotalTotal { get; set; }


         /// <summary>
         /// Constructor
         /// </summary>
         public SummaryOfSalesByYearBase()
         {
         }

         /// <summary>
         /// Gets the total number of records in the SummaryOfSalesByYear table
         /// </summary>
         public static int GetRecordCount()
         {
             return SummaryOfSalesByYearDataLayer.GetRecordCount();
         }

         /// <summary>
         /// Selects records as a collection (List) of SummaryOfSalesByYear sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         /// </summary>
         public static SummaryOfSalesByYearCollection SelectSkipAndTake(int rows, int startRowIndex, out int totalRowCount, string sortByExpression)
         {
             totalRowCount = GetRecordCount();
             sortByExpression = GetSortExpression(sortByExpression);

             return SummaryOfSalesByYearDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows);
         }

         /// <summary>
         /// Selects records as a collection (List) of SummaryOfSalesByYear sorted by the sortByExpression starting from the startRowIndex.
         /// </summary>
         public static SummaryOfSalesByYearCollection SelectSkipAndTake(int rows, int startRowIndex, string sortByExpression)
         {
             sortByExpression = GetSortExpression(sortByExpression);
             return SummaryOfSalesByYearDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows);
         }

         private static string GetSortExpression(string sortByExpression)
         {
             if (String.IsNullOrEmpty(sortByExpression) || sortByExpression == " asc")
                 sortByExpression = "ShippedDate";
             else if (sortByExpression.Contains(" asc"))
                 sortByExpression = sortByExpression.Replace(" asc", "");

             return sortByExpression;
         }

         /// <summary>
         /// Compares ShippedDate used for sorting
         /// </summary>
         public static Comparison<SummaryOfSalesByYear> ByShippedDate = delegate(SummaryOfSalesByYear x, SummaryOfSalesByYear y)
         {
             return Nullable.Compare(x.ShippedDate, y.ShippedDate);
         };

         /// <summary>
         /// Compares OrderID used for sorting
         /// </summary>
         public static Comparison<SummaryOfSalesByYear> ByOrderID = delegate(SummaryOfSalesByYear x, SummaryOfSalesByYear y)
         {
             return x.OrderID.CompareTo(y.OrderID);
         };

         /// <summary>
         /// Compares Subtotal used for sorting
         /// </summary>
         public static Comparison<SummaryOfSalesByYear> BySubtotal = delegate(SummaryOfSalesByYear x, SummaryOfSalesByYear y)
         {
             return Nullable.Compare(x.Subtotal, y.Subtotal);
         };

     }
}
