using System;
using System.Data;
using System.Data.SqlClient;
using NorthwindWinFormViewsDynamic_CS.BusinessObject;
using System.Configuration;

namespace NorthwindWinFormViewsDynamic_CS.DataLayer.Base
{
     /// <summary>
     /// Base class for AlphabeticalListOfProductsDataLayer.  Do not make changes to this class,
     /// instead, put additional code in the AlphabeticalListOfProductsDataLayer class
     /// </summary>
     public class AlphabeticalListOfProductsDataLayerBase
     {
         // constructor
         public AlphabeticalListOfProductsDataLayerBase()
         {
         }

         public static AlphabeticalListOfProductsCollection SelectShared(string dynamicSqlScript, string param, object paramValue, string sortByExpression = null, int? startRowIndex = null, int? rows = null)
         {
              AlphabeticalListOfProductsCollection objAlphabeticalListOfProductsCol = null;

              using (SqlConnection connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString))
              {
                  connection.Open();

                  using (SqlCommand command = new SqlCommand(dynamicSqlScript, connection))
                  {
                      command.CommandType = CommandType.Text;

                      // select, skip, take, sort parameters
                      if (!String.IsNullOrEmpty(sortByExpression) && startRowIndex != null && rows != null)
                      {
                          command.Parameters.AddWithValue("@start", startRowIndex.Value);
                          command.Parameters.AddWithValue("@numberOfRows", rows.Value);
                          command.Parameters.AddWithValue("@sortByExpression", sortByExpression);
                      }

                      using (SqlDataAdapter da = new SqlDataAdapter(command))
                      {
                          DataTable dt = new DataTable();
                          da.Fill(dt);

                          if (dt != null)
                          {
                              if (dt.Rows.Count > 0)
                              {
                                  objAlphabeticalListOfProductsCol = new AlphabeticalListOfProductsCollection();

                                  foreach (DataRow dr in dt.Rows)
                                  {
                                      AlphabeticalListOfProducts objAlphabeticalListOfProducts = CreateAlphabeticalListOfProductsFromDataRowShared(dr);
                                      objAlphabeticalListOfProductsCol.Add(objAlphabeticalListOfProducts);
                                  }
                              }
                          }
                      }
                  }
              }

              return objAlphabeticalListOfProductsCol;
         }

         /// <summary>
         /// Gets the total number of records in the AlphabeticalListOfProducts table
         /// </summary>
         public static int GetRecordCount()
         {
             string sql = AlphabeticalListOfProductsSql.GetRecordCount();
             return GetRecordCountShared(null, null, null, false, sql);
         }

         public static int GetRecordCountShared(string storedProcName = null, string param = null, object paramValue = null, bool isUseStoredProc = true, string dynamicSqlScript = null)
         {
              int recordCount = 0;

              using (SqlConnection connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString))
              {
                  connection.Open();

                  using (SqlCommand command = new SqlCommand(dynamicSqlScript, connection))
                  {
                      command.CommandType = CommandType.Text;

                      using (SqlDataAdapter da = new SqlDataAdapter(command))
                      {
                          DataTable dt = new DataTable();
                          da.Fill(dt);

                          if (dt != null)
                          {
                              if (dt.Rows.Count > 0)
                              {
                                  recordCount = (int)dt.Rows[0]["RecordCount"];
                              }
                          }
                      }
                  }
              }

              return recordCount;
         }

         /// <summary>
         /// Selects AlphabeticalListOfProducts records sorted by the sortByExpression and returns records from the startRowIndex with rows (# of rows)
         /// </summary>
         public static AlphabeticalListOfProductsCollection SelectSkipAndTake(string sortByExpression, int startRowIndex, int rows)
         {
             string dynamicSqlScript = AlphabeticalListOfProductsSql.SelectSkipAndTake();
             return SelectShared(dynamicSqlScript, null, null, sortByExpression, startRowIndex, rows);
         }

         /// <summary>
         /// Creates a AlphabeticalListOfProducts object from the passed data row
         /// </summary>
         private static AlphabeticalListOfProducts CreateAlphabeticalListOfProductsFromDataRowShared(DataRow dr)
         {
             AlphabeticalListOfProducts objAlphabeticalListOfProducts = new AlphabeticalListOfProducts();

             objAlphabeticalListOfProducts.ProductID = (int)dr["ProductID"];
             objAlphabeticalListOfProducts.ProductName = dr["ProductName"].ToString();

             if (dr["SupplierID"] != System.DBNull.Value)
                 objAlphabeticalListOfProducts.SupplierID = (int)dr["SupplierID"];
             else
                 objAlphabeticalListOfProducts.SupplierID = null;

             if (dr["CategoryID"] != System.DBNull.Value)
                 objAlphabeticalListOfProducts.CategoryID = (int)dr["CategoryID"];
             else
                 objAlphabeticalListOfProducts.CategoryID = null;

             if (dr["QuantityPerUnit"] != System.DBNull.Value)
                 objAlphabeticalListOfProducts.QuantityPerUnit = dr["QuantityPerUnit"].ToString();
             else
                 objAlphabeticalListOfProducts.QuantityPerUnit = null;

             if (dr["UnitPrice"] != System.DBNull.Value)
                 objAlphabeticalListOfProducts.UnitPrice = (decimal)dr["UnitPrice"];
             else
                 objAlphabeticalListOfProducts.UnitPrice = null;

             if (dr["UnitsInStock"] != System.DBNull.Value)
                 objAlphabeticalListOfProducts.UnitsInStock = (Int16)dr["UnitsInStock"];
             else
                 objAlphabeticalListOfProducts.UnitsInStock = null;

             if (dr["UnitsOnOrder"] != System.DBNull.Value)
                 objAlphabeticalListOfProducts.UnitsOnOrder = (Int16)dr["UnitsOnOrder"];
             else
                 objAlphabeticalListOfProducts.UnitsOnOrder = null;

             if (dr["ReorderLevel"] != System.DBNull.Value)
                 objAlphabeticalListOfProducts.ReorderLevel = (Int16)dr["ReorderLevel"];
             else
                 objAlphabeticalListOfProducts.ReorderLevel = null;
             objAlphabeticalListOfProducts.Discontinued = (bool)dr["Discontinued"];
             objAlphabeticalListOfProducts.CategoryName = dr["CategoryName"].ToString();

             return objAlphabeticalListOfProducts;
         }
     }
}
