using System;
using System.Data;
using System.Data.SqlClient;
using NorthwindWinFormViewsDynamic_CS.BusinessObject;
using System.Configuration;

namespace NorthwindWinFormViewsDynamic_CS.DataLayer.Base
{
     /// <summary>
     /// Base class for CategorySalesFor1997DataLayer.  Do not make changes to this class,
     /// instead, put additional code in the CategorySalesFor1997DataLayer class
     /// </summary>
     public class CategorySalesFor1997DataLayerBase
     {
         // constructor
         public CategorySalesFor1997DataLayerBase()
         {
         }

         public static CategorySalesFor1997Collection SelectShared(string dynamicSqlScript, string param, object paramValue, string sortByExpression = null, int? startRowIndex = null, int? rows = null)
         {
              CategorySalesFor1997Collection objCategorySalesFor1997Col = null;

              using (SqlConnection connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString))
              {
                  connection.Open();

                  using (SqlCommand command = new SqlCommand(dynamicSqlScript, connection))
                  {
                      command.CommandType = CommandType.Text;

                      // select, skip, take, sort parameters
                      if (!String.IsNullOrEmpty(sortByExpression) && startRowIndex != null && rows != null)
                      {
                          command.Parameters.AddWithValue("@start", startRowIndex.Value);
                          command.Parameters.AddWithValue("@numberOfRows", rows.Value);
                          command.Parameters.AddWithValue("@sortByExpression", sortByExpression);
                      }

                      using (SqlDataAdapter da = new SqlDataAdapter(command))
                      {
                          DataTable dt = new DataTable();
                          da.Fill(dt);

                          if (dt != null)
                          {
                              if (dt.Rows.Count > 0)
                              {
                                  objCategorySalesFor1997Col = new CategorySalesFor1997Collection();

                                  foreach (DataRow dr in dt.Rows)
                                  {
                                      CategorySalesFor1997 objCategorySalesFor1997 = CreateCategorySalesFor1997FromDataRowShared(dr);
                                      objCategorySalesFor1997Col.Add(objCategorySalesFor1997);
                                  }
                              }
                          }
                      }
                  }
              }

              return objCategorySalesFor1997Col;
         }

         /// <summary>
         /// Gets the total number of records in the CategorySalesFor1997 table
         /// </summary>
         public static int GetRecordCount()
         {
             string sql = CategorySalesFor1997Sql.GetRecordCount();
             return GetRecordCountShared(null, null, null, false, sql);
         }

         public static int GetRecordCountShared(string storedProcName = null, string param = null, object paramValue = null, bool isUseStoredProc = true, string dynamicSqlScript = null)
         {
              int recordCount = 0;

              using (SqlConnection connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString))
              {
                  connection.Open();

                  using (SqlCommand command = new SqlCommand(dynamicSqlScript, connection))
                  {
                      command.CommandType = CommandType.Text;

                      using (SqlDataAdapter da = new SqlDataAdapter(command))
                      {
                          DataTable dt = new DataTable();
                          da.Fill(dt);

                          if (dt != null)
                          {
                              if (dt.Rows.Count > 0)
                              {
                                  recordCount = (int)dt.Rows[0]["RecordCount"];
                              }
                          }
                      }
                  }
              }

              return recordCount;
         }

         /// <summary>
         /// Selects CategorySalesFor1997 records sorted by the sortByExpression and returns records from the startRowIndex with rows (# of rows)
         /// </summary>
         public static CategorySalesFor1997Collection SelectSkipAndTake(string sortByExpression, int startRowIndex, int rows)
         {
             string dynamicSqlScript = CategorySalesFor1997Sql.SelectSkipAndTake();
             return SelectShared(dynamicSqlScript, null, null, sortByExpression, startRowIndex, rows);
         }

         /// <summary>
         /// Creates a CategorySalesFor1997 object from the passed data row
         /// </summary>
         private static CategorySalesFor1997 CreateCategorySalesFor1997FromDataRowShared(DataRow dr)
         {
             CategorySalesFor1997 objCategorySalesFor1997 = new CategorySalesFor1997();

             objCategorySalesFor1997.CategoryName = dr["CategoryName"].ToString();

             if (dr["CategorySales"] != System.DBNull.Value)
                 objCategorySalesFor1997.CategorySales = (decimal)dr["CategorySales"];
             else
                 objCategorySalesFor1997.CategorySales = null;

             return objCategorySalesFor1997;
         }
     }
}
