using System;
using System.Data;
using System.Data.SqlClient;
using NorthwindWinFormViewsDynamic_CS.BusinessObject;
using System.Configuration;

namespace NorthwindWinFormViewsDynamic_CS.DataLayer.Base
{
     /// <summary>
     /// Base class for ProductSalesFor1997DataLayer.  Do not make changes to this class,
     /// instead, put additional code in the ProductSalesFor1997DataLayer class
     /// </summary>
     public class ProductSalesFor1997DataLayerBase
     {
         // constructor
         public ProductSalesFor1997DataLayerBase()
         {
         }

         public static ProductSalesFor1997Collection SelectShared(string dynamicSqlScript, string param, object paramValue, string sortByExpression = null, int? startRowIndex = null, int? rows = null)
         {
              ProductSalesFor1997Collection objProductSalesFor1997Col = null;

              using (SqlConnection connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString))
              {
                  connection.Open();

                  using (SqlCommand command = new SqlCommand(dynamicSqlScript, connection))
                  {
                      command.CommandType = CommandType.Text;

                      // select, skip, take, sort parameters
                      if (!String.IsNullOrEmpty(sortByExpression) && startRowIndex != null && rows != null)
                      {
                          command.Parameters.AddWithValue("@start", startRowIndex.Value);
                          command.Parameters.AddWithValue("@numberOfRows", rows.Value);
                          command.Parameters.AddWithValue("@sortByExpression", sortByExpression);
                      }

                      using (SqlDataAdapter da = new SqlDataAdapter(command))
                      {
                          DataTable dt = new DataTable();
                          da.Fill(dt);

                          if (dt != null)
                          {
                              if (dt.Rows.Count > 0)
                              {
                                  objProductSalesFor1997Col = new ProductSalesFor1997Collection();

                                  foreach (DataRow dr in dt.Rows)
                                  {
                                      ProductSalesFor1997 objProductSalesFor1997 = CreateProductSalesFor1997FromDataRowShared(dr);
                                      objProductSalesFor1997Col.Add(objProductSalesFor1997);
                                  }
                              }
                          }
                      }
                  }
              }

              return objProductSalesFor1997Col;
         }

         /// <summary>
         /// Gets the total number of records in the ProductSalesFor1997 table
         /// </summary>
         public static int GetRecordCount()
         {
             string sql = ProductSalesFor1997Sql.GetRecordCount();
             return GetRecordCountShared(null, null, null, false, sql);
         }

         public static int GetRecordCountShared(string storedProcName = null, string param = null, object paramValue = null, bool isUseStoredProc = true, string dynamicSqlScript = null)
         {
              int recordCount = 0;

              using (SqlConnection connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString))
              {
                  connection.Open();

                  using (SqlCommand command = new SqlCommand(dynamicSqlScript, connection))
                  {
                      command.CommandType = CommandType.Text;

                      using (SqlDataAdapter da = new SqlDataAdapter(command))
                      {
                          DataTable dt = new DataTable();
                          da.Fill(dt);

                          if (dt != null)
                          {
                              if (dt.Rows.Count > 0)
                              {
                                  recordCount = (int)dt.Rows[0]["RecordCount"];
                              }
                          }
                      }
                  }
              }

              return recordCount;
         }

         /// <summary>
         /// Selects ProductSalesFor1997 records sorted by the sortByExpression and returns records from the startRowIndex with rows (# of rows)
         /// </summary>
         public static ProductSalesFor1997Collection SelectSkipAndTake(string sortByExpression, int startRowIndex, int rows)
         {
             string dynamicSqlScript = ProductSalesFor1997Sql.SelectSkipAndTake();
             return SelectShared(dynamicSqlScript, null, null, sortByExpression, startRowIndex, rows);
         }

         /// <summary>
         /// Creates a ProductSalesFor1997 object from the passed data row
         /// </summary>
         private static ProductSalesFor1997 CreateProductSalesFor1997FromDataRowShared(DataRow dr)
         {
             ProductSalesFor1997 objProductSalesFor1997 = new ProductSalesFor1997();

             objProductSalesFor1997.CategoryName = dr["CategoryName"].ToString();
             objProductSalesFor1997.ProductName = dr["ProductName"].ToString();

             if (dr["ProductSales"] != System.DBNull.Value)
                 objProductSalesFor1997.ProductSales = (decimal)dr["ProductSales"];
             else
                 objProductSalesFor1997.ProductSales = null;

             return objProductSalesFor1997;
         }
     }
}
