using System;
using System.Data;
using System.Data.SqlClient;
using NorthwindWinFormViewsDynamic_CS.BusinessObject;
using System.Configuration;

namespace NorthwindWinFormViewsDynamic_CS.DataLayer.Base
{
     /// <summary>
     /// Base class for SummaryOfSalesByQuarterDataLayer.  Do not make changes to this class,
     /// instead, put additional code in the SummaryOfSalesByQuarterDataLayer class
     /// </summary>
     public class SummaryOfSalesByQuarterDataLayerBase
     {
         // constructor
         public SummaryOfSalesByQuarterDataLayerBase()
         {
         }

         public static SummaryOfSalesByQuarterCollection SelectShared(string dynamicSqlScript, string param, object paramValue, string sortByExpression = null, int? startRowIndex = null, int? rows = null)
         {
              SummaryOfSalesByQuarterCollection objSummaryOfSalesByQuarterCol = null;

              using (SqlConnection connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString))
              {
                  connection.Open();

                  using (SqlCommand command = new SqlCommand(dynamicSqlScript, connection))
                  {
                      command.CommandType = CommandType.Text;

                      // select, skip, take, sort parameters
                      if (!String.IsNullOrEmpty(sortByExpression) && startRowIndex != null && rows != null)
                      {
                          command.Parameters.AddWithValue("@start", startRowIndex.Value);
                          command.Parameters.AddWithValue("@numberOfRows", rows.Value);
                          command.Parameters.AddWithValue("@sortByExpression", sortByExpression);
                      }

                      using (SqlDataAdapter da = new SqlDataAdapter(command))
                      {
                          DataTable dt = new DataTable();
                          da.Fill(dt);

                          if (dt != null)
                          {
                              if (dt.Rows.Count > 0)
                              {
                                  objSummaryOfSalesByQuarterCol = new SummaryOfSalesByQuarterCollection();

                                  foreach (DataRow dr in dt.Rows)
                                  {
                                      SummaryOfSalesByQuarter objSummaryOfSalesByQuarter = CreateSummaryOfSalesByQuarterFromDataRowShared(dr);
                                      objSummaryOfSalesByQuarterCol.Add(objSummaryOfSalesByQuarter);
                                  }
                              }
                          }
                      }
                  }
              }

              return objSummaryOfSalesByQuarterCol;
         }

         /// <summary>
         /// Gets the total number of records in the SummaryOfSalesByQuarter table
         /// </summary>
         public static int GetRecordCount()
         {
             string sql = SummaryOfSalesByQuarterSql.GetRecordCount();
             return GetRecordCountShared(null, null, null, false, sql);
         }

         public static int GetRecordCountShared(string storedProcName = null, string param = null, object paramValue = null, bool isUseStoredProc = true, string dynamicSqlScript = null)
         {
              int recordCount = 0;

              using (SqlConnection connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString))
              {
                  connection.Open();

                  using (SqlCommand command = new SqlCommand(dynamicSqlScript, connection))
                  {
                      command.CommandType = CommandType.Text;

                      using (SqlDataAdapter da = new SqlDataAdapter(command))
                      {
                          DataTable dt = new DataTable();
                          da.Fill(dt);

                          if (dt != null)
                          {
                              if (dt.Rows.Count > 0)
                              {
                                  recordCount = (int)dt.Rows[0]["RecordCount"];
                              }
                          }
                      }
                  }
              }

              return recordCount;
         }

         /// <summary>
         /// Selects SummaryOfSalesByQuarter records sorted by the sortByExpression and returns records from the startRowIndex with rows (# of rows)
         /// </summary>
         public static SummaryOfSalesByQuarterCollection SelectSkipAndTake(string sortByExpression, int startRowIndex, int rows)
         {
             string dynamicSqlScript = SummaryOfSalesByQuarterSql.SelectSkipAndTake();
             return SelectShared(dynamicSqlScript, null, null, sortByExpression, startRowIndex, rows);
         }

         /// <summary>
         /// Creates a SummaryOfSalesByQuarter object from the passed data row
         /// </summary>
         private static SummaryOfSalesByQuarter CreateSummaryOfSalesByQuarterFromDataRowShared(DataRow dr)
         {
             SummaryOfSalesByQuarter objSummaryOfSalesByQuarter = new SummaryOfSalesByQuarter();


             if (dr["ShippedDate"] != System.DBNull.Value)
                 objSummaryOfSalesByQuarter.ShippedDate = (DateTime)dr["ShippedDate"];
             else
                 objSummaryOfSalesByQuarter.ShippedDate = null;
             objSummaryOfSalesByQuarter.OrderID = (int)dr["OrderID"];

             if (dr["Subtotal"] != System.DBNull.Value)
                 objSummaryOfSalesByQuarter.Subtotal = (decimal)dr["Subtotal"];
             else
                 objSummaryOfSalesByQuarter.Subtotal = null;

             return objSummaryOfSalesByQuarter;
         }
     }
}
