using System;
using System.Data;
using System.Data.SqlClient;
using NorthwindWinFormViewsDynamic_CS.BusinessObject;
using System.Configuration;

namespace NorthwindWinFormViewsDynamic_CS.DataLayer.Base
{
     /// <summary>
     /// Base class for SummaryOfSalesByYearDataLayer.  Do not make changes to this class,
     /// instead, put additional code in the SummaryOfSalesByYearDataLayer class
     /// </summary>
     public class SummaryOfSalesByYearDataLayerBase
     {
         // constructor
         public SummaryOfSalesByYearDataLayerBase()
         {
         }

         public static SummaryOfSalesByYearCollection SelectShared(string dynamicSqlScript, string param, object paramValue, string sortByExpression = null, int? startRowIndex = null, int? rows = null)
         {
              SummaryOfSalesByYearCollection objSummaryOfSalesByYearCol = null;

              using (SqlConnection connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString))
              {
                  connection.Open();

                  using (SqlCommand command = new SqlCommand(dynamicSqlScript, connection))
                  {
                      command.CommandType = CommandType.Text;

                      // select, skip, take, sort parameters
                      if (!String.IsNullOrEmpty(sortByExpression) && startRowIndex != null && rows != null)
                      {
                          command.Parameters.AddWithValue("@start", startRowIndex.Value);
                          command.Parameters.AddWithValue("@numberOfRows", rows.Value);
                          command.Parameters.AddWithValue("@sortByExpression", sortByExpression);
                      }

                      using (SqlDataAdapter da = new SqlDataAdapter(command))
                      {
                          DataTable dt = new DataTable();
                          da.Fill(dt);

                          if (dt != null)
                          {
                              if (dt.Rows.Count > 0)
                              {
                                  objSummaryOfSalesByYearCol = new SummaryOfSalesByYearCollection();

                                  foreach (DataRow dr in dt.Rows)
                                  {
                                      SummaryOfSalesByYear objSummaryOfSalesByYear = CreateSummaryOfSalesByYearFromDataRowShared(dr);
                                      objSummaryOfSalesByYearCol.Add(objSummaryOfSalesByYear);
                                  }
                              }
                          }
                      }
                  }
              }

              return objSummaryOfSalesByYearCol;
         }

         /// <summary>
         /// Gets the total number of records in the SummaryOfSalesByYear table
         /// </summary>
         public static int GetRecordCount()
         {
             string sql = SummaryOfSalesByYearSql.GetRecordCount();
             return GetRecordCountShared(null, null, null, false, sql);
         }

         public static int GetRecordCountShared(string storedProcName = null, string param = null, object paramValue = null, bool isUseStoredProc = true, string dynamicSqlScript = null)
         {
              int recordCount = 0;

              using (SqlConnection connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString))
              {
                  connection.Open();

                  using (SqlCommand command = new SqlCommand(dynamicSqlScript, connection))
                  {
                      command.CommandType = CommandType.Text;

                      using (SqlDataAdapter da = new SqlDataAdapter(command))
                      {
                          DataTable dt = new DataTable();
                          da.Fill(dt);

                          if (dt != null)
                          {
                              if (dt.Rows.Count > 0)
                              {
                                  recordCount = (int)dt.Rows[0]["RecordCount"];
                              }
                          }
                      }
                  }
              }

              return recordCount;
         }

         /// <summary>
         /// Selects SummaryOfSalesByYear records sorted by the sortByExpression and returns records from the startRowIndex with rows (# of rows)
         /// </summary>
         public static SummaryOfSalesByYearCollection SelectSkipAndTake(string sortByExpression, int startRowIndex, int rows)
         {
             string dynamicSqlScript = SummaryOfSalesByYearSql.SelectSkipAndTake();
             return SelectShared(dynamicSqlScript, null, null, sortByExpression, startRowIndex, rows);
         }

         /// <summary>
         /// Creates a SummaryOfSalesByYear object from the passed data row
         /// </summary>
         private static SummaryOfSalesByYear CreateSummaryOfSalesByYearFromDataRowShared(DataRow dr)
         {
             SummaryOfSalesByYear objSummaryOfSalesByYear = new SummaryOfSalesByYear();


             if (dr["ShippedDate"] != System.DBNull.Value)
                 objSummaryOfSalesByYear.ShippedDate = (DateTime)dr["ShippedDate"];
             else
                 objSummaryOfSalesByYear.ShippedDate = null;
             objSummaryOfSalesByYear.OrderID = (int)dr["OrderID"];

             if (dr["Subtotal"] != System.DBNull.Value)
                 objSummaryOfSalesByYear.Subtotal = (decimal)dr["Subtotal"];
             else
                 objSummaryOfSalesByYear.Subtotal = null;

             return objSummaryOfSalesByYear;
         }
     }
}
