using System; 
using System.Text; 

namespace NorthwindWinFormViewsDynamic_CS.DataLayer.Base
{ 
    public sealed class CustomerAndSuppliersByCitySql 
    { 
        private CustomerAndSuppliersByCitySql() 
        { 
        } 

        public static string GetRecordCount() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Customer and Suppliers by City]");

            return sb.ToString(); 
        } 

        public static string SelectSkipAndTake() 
        { 
            string selectStatement = GetSelectStatement(); 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ");

            sb.Append("SELECT ");
            sb.Append("[City], ");
            sb.Append("[CompanyName], ");
            sb.Append("[ContactName], ");
            sb.Append("[Relationship] ");
            sb.Append("FROM [dbo].[Customer and Suppliers by City] ");
            sb.Append("ORDER BY ");
	        sb.Append("CASE WHEN @sortByExpression = 'City' THEN [City] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'City desc' THEN [City] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName' THEN [CompanyName] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName desc' THEN [CompanyName] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'ContactName' THEN [ContactName] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'ContactName desc' THEN [ContactName] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'Relationship' THEN [Relationship] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'Relationship desc' THEN [Relationship] END DESC ");

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ");
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ");

            return sb.ToString(); 
        } 

        private static string GetSelectStatement() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT ");
            sb.Append("[City], ");
            sb.Append("[CompanyName], ");
            sb.Append("[ContactName], ");
            sb.Append("[Relationship] ");
            sb.Append("FROM [dbo].[Customer and Suppliers by City] ");

            return sb.ToString(); 
        } 
    } 
} 
