using System; 
using System.Text; 

namespace NorthwindWinFormViewsDynamic_CS.DataLayer.Base
{ 
    public sealed class OrderDetailsExtendedSql 
    { 
        private OrderDetailsExtendedSql() 
        { 
        } 

        public static string GetRecordCount() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Order Details Extended]");

            return sb.ToString(); 
        } 

        public static string SelectSkipAndTake() 
        { 
            string selectStatement = GetSelectStatement(); 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ");

            sb.Append("SELECT ");
            sb.Append("[OrderID], ");
            sb.Append("[ProductID], ");
            sb.Append("[ProductName], ");
            sb.Append("[UnitPrice], ");
            sb.Append("[Quantity], ");
            sb.Append("[Discount], ");
            sb.Append("[ExtendedPrice] ");
            sb.Append("FROM [dbo].[Order Details Extended] ");
            sb.Append("ORDER BY ");
	        sb.Append("CASE WHEN @sortByExpression = 'OrderID' THEN [OrderID] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'OrderID desc' THEN [OrderID] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'ProductID' THEN [ProductID] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'ProductID desc' THEN [ProductID] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'ProductName' THEN [ProductName] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'ProductName desc' THEN [ProductName] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'UnitPrice' THEN [UnitPrice] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'UnitPrice desc' THEN [UnitPrice] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'Quantity' THEN [Quantity] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'Quantity desc' THEN [Quantity] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'Discount' THEN [Discount] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'Discount desc' THEN [Discount] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'ExtendedPrice' THEN [ExtendedPrice] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'ExtendedPrice desc' THEN [ExtendedPrice] END DESC ");

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ");
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ");

            return sb.ToString(); 
        } 

        private static string GetSelectStatement() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT ");
            sb.Append("[OrderID], ");
            sb.Append("[ProductID], ");
            sb.Append("[ProductName], ");
            sb.Append("[UnitPrice], ");
            sb.Append("[Quantity], ");
            sb.Append("[Discount], ");
            sb.Append("[ExtendedPrice] ");
            sb.Append("FROM [dbo].[Order Details Extended] ");

            return sb.ToString(); 
        } 
    } 
} 
