using System; 
using System.Text; 

namespace NorthwindWinFormViewsDynamic_CS.DataLayer.Base
{ 
    public sealed class OrderSubtotalsSql 
    { 
        private OrderSubtotalsSql() 
        { 
        } 

        public static string GetRecordCount() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Order Subtotals]");

            return sb.ToString(); 
        } 

        public static string SelectSkipAndTake() 
        { 
            string selectStatement = GetSelectStatement(); 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ");

            sb.Append("SELECT ");
            sb.Append("[OrderID], ");
            sb.Append("[Subtotal] ");
            sb.Append("FROM [dbo].[Order Subtotals] ");
            sb.Append("ORDER BY ");
	        sb.Append("CASE WHEN @sortByExpression = 'OrderID' THEN [OrderID] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'OrderID desc' THEN [OrderID] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'Subtotal' THEN [Subtotal] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'Subtotal desc' THEN [Subtotal] END DESC ");

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ");
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ");

            return sb.ToString(); 
        } 

        private static string GetSelectStatement() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT ");
            sb.Append("[OrderID], ");
            sb.Append("[Subtotal] ");
            sb.Append("FROM [dbo].[Order Subtotals] ");

            return sb.ToString(); 
        } 
    } 
} 
