using System; 
using System.Text; 

namespace NorthwindWinFormViewsDynamic_CS.DataLayer.Base
{ 
    public sealed class OrdersQrySql 
    { 
        private OrdersQrySql() 
        { 
        } 

        public static string GetRecordCount() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Orders Qry]");

            return sb.ToString(); 
        } 

        public static string SelectSkipAndTake() 
        { 
            string selectStatement = GetSelectStatement(); 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ");

            sb.Append("SELECT ");
            sb.Append("[OrderID], ");
            sb.Append("[CustomerID], ");
            sb.Append("[EmployeeID], ");
            sb.Append("[OrderDate], ");
            sb.Append("[RequiredDate], ");
            sb.Append("[ShippedDate], ");
            sb.Append("[ShipVia], ");
            sb.Append("[Freight], ");
            sb.Append("[ShipName], ");
            sb.Append("[ShipAddress], ");
            sb.Append("[ShipCity], ");
            sb.Append("[ShipRegion], ");
            sb.Append("[ShipPostalCode], ");
            sb.Append("[ShipCountry], ");
            sb.Append("[CompanyName], ");
            sb.Append("[Address], ");
            sb.Append("[City], ");
            sb.Append("[Region] AS [Region1], ");
            sb.Append("[PostalCode], ");
            sb.Append("[Country] ");
            sb.Append("FROM [dbo].[Orders Qry] ");
            sb.Append("ORDER BY ");
	        sb.Append("CASE WHEN @sortByExpression = 'OrderID' THEN [OrderID] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'OrderID desc' THEN [OrderID] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'CustomerID' THEN [CustomerID] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'CustomerID desc' THEN [CustomerID] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'EmployeeID' THEN [EmployeeID] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'EmployeeID desc' THEN [EmployeeID] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'OrderDate' THEN [OrderDate] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'OrderDate desc' THEN [OrderDate] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'RequiredDate' THEN [RequiredDate] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'RequiredDate desc' THEN [RequiredDate] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'ShippedDate' THEN [ShippedDate] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'ShippedDate desc' THEN [ShippedDate] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'ShipVia' THEN [ShipVia] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'ShipVia desc' THEN [ShipVia] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'Freight' THEN [Freight] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'Freight desc' THEN [Freight] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'ShipName' THEN [ShipName] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'ShipName desc' THEN [ShipName] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'ShipAddress' THEN [ShipAddress] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'ShipAddress desc' THEN [ShipAddress] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'ShipCity' THEN [ShipCity] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'ShipCity desc' THEN [ShipCity] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'ShipRegion' THEN [ShipRegion] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'ShipRegion desc' THEN [ShipRegion] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'ShipPostalCode' THEN [ShipPostalCode] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'ShipPostalCode desc' THEN [ShipPostalCode] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'ShipCountry' THEN [ShipCountry] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'ShipCountry desc' THEN [ShipCountry] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName' THEN [CompanyName] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName desc' THEN [CompanyName] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'Address' THEN [Address] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'Address desc' THEN [Address] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'City' THEN [City] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'City desc' THEN [City] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'Region1' THEN [Region] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'Region1 desc' THEN [Region] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'PostalCode' THEN [PostalCode] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'PostalCode desc' THEN [PostalCode] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'Country' THEN [Country] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'Country desc' THEN [Country] END DESC ");

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ");
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ");

            return sb.ToString(); 
        } 

        private static string GetSelectStatement() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT ");
            sb.Append("[OrderID], ");
            sb.Append("[CustomerID], ");
            sb.Append("[EmployeeID], ");
            sb.Append("[OrderDate], ");
            sb.Append("[RequiredDate], ");
            sb.Append("[ShippedDate], ");
            sb.Append("[ShipVia], ");
            sb.Append("[Freight], ");
            sb.Append("[ShipName], ");
            sb.Append("[ShipAddress], ");
            sb.Append("[ShipCity], ");
            sb.Append("[ShipRegion], ");
            sb.Append("[ShipPostalCode], ");
            sb.Append("[ShipCountry], ");
            sb.Append("[CompanyName], ");
            sb.Append("[Address], ");
            sb.Append("[City], ");
            sb.Append("[Region] AS [Region1], ");
            sb.Append("[PostalCode], ");
            sb.Append("[Country] ");
            sb.Append("FROM [dbo].[Orders Qry] ");

            return sb.ToString(); 
        } 
    } 
} 
