using System; 
using System.Text; 

namespace NorthwindWinFormViewsDynamic_CS.DataLayer.Base
{ 
    public sealed class ProductSalesFor1997Sql 
    { 
        private ProductSalesFor1997Sql() 
        { 
        } 

        public static string GetRecordCount() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Product Sales for 1997]");

            return sb.ToString(); 
        } 

        public static string SelectSkipAndTake() 
        { 
            string selectStatement = GetSelectStatement(); 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ");

            sb.Append("SELECT ");
            sb.Append("[CategoryName], ");
            sb.Append("[ProductName], ");
            sb.Append("[ProductSales] ");
            sb.Append("FROM [dbo].[Product Sales for 1997] ");
            sb.Append("ORDER BY ");
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName' THEN [CategoryName] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName desc' THEN [CategoryName] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'ProductName' THEN [ProductName] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'ProductName desc' THEN [ProductName] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'ProductSales' THEN [ProductSales] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'ProductSales desc' THEN [ProductSales] END DESC ");

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ");
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ");

            return sb.ToString(); 
        } 

        private static string GetSelectStatement() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT ");
            sb.Append("[CategoryName], ");
            sb.Append("[ProductName], ");
            sb.Append("[ProductSales] ");
            sb.Append("FROM [dbo].[Product Sales for 1997] ");

            return sb.ToString(); 
        } 
    } 
} 
