using System; 
using System.Text; 

namespace NorthwindWinFormViewsDynamic_CS.DataLayer.Base
{ 
    public sealed class QuarterlyOrdersSql 
    { 
        private QuarterlyOrdersSql() 
        { 
        } 

        public static string GetRecordCount() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Quarterly Orders]");

            return sb.ToString(); 
        } 

        public static string SelectSkipAndTake() 
        { 
            string selectStatement = GetSelectStatement(); 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ");

            sb.Append("SELECT ");
            sb.Append("[CustomerID], ");
            sb.Append("[CompanyName], ");
            sb.Append("[City], ");
            sb.Append("[Country] ");
            sb.Append("FROM [dbo].[Quarterly Orders] ");
            sb.Append("ORDER BY ");
	        sb.Append("CASE WHEN @sortByExpression = 'CustomerID' THEN [CustomerID] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'CustomerID desc' THEN [CustomerID] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName' THEN [CompanyName] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName desc' THEN [CompanyName] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'City' THEN [City] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'City desc' THEN [City] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'Country' THEN [Country] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'Country desc' THEN [Country] END DESC ");

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ");
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ");

            return sb.ToString(); 
        } 

        private static string GetSelectStatement() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT ");
            sb.Append("[CustomerID], ");
            sb.Append("[CompanyName], ");
            sb.Append("[City], ");
            sb.Append("[Country] ");
            sb.Append("FROM [dbo].[Quarterly Orders] ");

            return sb.ToString(); 
        } 
    } 
} 
