using System; 
using System.Text; 

namespace NorthwindWinFormViewsDynamic_CS.DataLayer.Base
{ 
    public sealed class SalesTotalsByAmountSql 
    { 
        private SalesTotalsByAmountSql() 
        { 
        } 

        public static string GetRecordCount() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Sales Totals by Amount]");

            return sb.ToString(); 
        } 

        public static string SelectSkipAndTake() 
        { 
            string selectStatement = GetSelectStatement(); 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ");

            sb.Append("SELECT ");
            sb.Append("[SaleAmount], ");
            sb.Append("[OrderID], ");
            sb.Append("[CompanyName], ");
            sb.Append("[ShippedDate] ");
            sb.Append("FROM [dbo].[Sales Totals by Amount] ");
            sb.Append("ORDER BY ");
	        sb.Append("CASE WHEN @sortByExpression = 'SaleAmount' THEN [SaleAmount] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'SaleAmount desc' THEN [SaleAmount] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'OrderID' THEN [OrderID] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'OrderID desc' THEN [OrderID] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName' THEN [CompanyName] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName desc' THEN [CompanyName] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'ShippedDate' THEN [ShippedDate] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'ShippedDate desc' THEN [ShippedDate] END DESC ");

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ");
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ");

            return sb.ToString(); 
        } 

        private static string GetSelectStatement() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT ");
            sb.Append("[SaleAmount], ");
            sb.Append("[OrderID], ");
            sb.Append("[CompanyName], ");
            sb.Append("[ShippedDate] ");
            sb.Append("FROM [dbo].[Sales Totals by Amount] ");

            return sb.ToString(); 
        } 
    } 
} 
